subroutine FM25(Fun, X, H, Eps)
!   f(x1,x2,...,xn)
! -
interface
  real function Fun(x)
    real, intent(in):: x(:)
  end function Fun
end interface
real, intent(in):: H, Eps
real, intent(inout):: X(:)
integer, parameter:: CCmax=1000
real, allocatable:: B(:), P(:), Y(:)
real Z, FI, FB, HH
real ME2, SQME, EE, Xmin
integer i, j, n, PS, BS, CC
!begin
    ! 
    ME2=epsilon(1.0); SQME=sqrt(0.5*ME2);
    !  
    EE=abs(Eps); if (EE<ME2) EE=ME2
    n=size(X); HH=H; CC=0
    allocate(B(n), P(n), Y(n))
    do i=1, n
        Y(i)=X(i); P(i)=X(i); B(i)=X(i);
    enddo
    Z=Fun(X); FI=Z
    !print *, 'The initial value of the function ', Z
    !print 33, (i, X(i), i=1, n)
    PS=0; BS=1
    !   
    j=1; FB=FI
200 continue
    CC=CC+1
    X(j)=Y(j)+HH; Z=Fun(X)
    if (Z<FI) goto 280
    X(j)=Y(j)-HH; Z=Fun(X)
    if (Z<FI) goto 280
    X(j)=Y(j)
    goto 290
280 Y(j)=X(j)
290 Z=Fun(X); FI=Z
    !print *, 'Exploring the search ', Z
    !print 33, (i, X(i), i=1, n)
    j=j+1
    if (j<=n) goto 200
360 if (FI<(FB-ME2)) goto 540
    !   ,    
    if (PS==1 .and. BS==0) goto 420
    !       PT
    !     ,  
    !    420
    !        490
    goto 490
420 do i=1, n
        P(i)=B(i); Y(i)=B(i); X(i)=B(i)
    enddo
    Z=Fun(X); FI=Z; FB=Z
    BS=1; PS=0
    !  
    !print *, 'Replacement reference ', Z
    !print 33, (i, X(i), i=1, n)
    j=1; goto 200
    !  
490 HH=0.1*HH
    !print *, 'To reduce the step length, H=', HH
    Xmin=0.0
    do i=1, n; if (Xmin<abs(X(i))) Xmin=abs(X(i)); enddo
    if ((CC>=CCmax).or.(HH<(SQME*Xmin+EE))) goto 700
    !   ,   
    !    
    j=1; goto 200
    !  
540 do i=1, n
        P(i)=2.0*Y(i)-B(i)
        B(i)=Y(i); X(i)=P(i); Y(i)=P(i)
    enddo
    Z=Fun(X); FB=FI; FI=Z; PS=1; BS=0
    !print *, 'Search by sample ', Z
    !print 33, (i, X(i), i=1, n)
    !      
    j=1; goto 200
    ! 
700 do i=1, n; X(i)=P(i); enddo
    print *, 'The minimum'
    print 33, (i, X(i), i=1, n)
    print *, 'The minimum of the function is', FB
    print *, 'The number of iterations', CC
    deallocate(B, P, Y)
33  format(<n>(2X,'X[',I1,']=',F9.6))
end subroutine FM25
